import com.motorola.io.file.FileConnection;
import com.motorola.io.file.FileSystemRegistry;

import javax.microedition.io.Connector;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: DG-SC
 * Date: 08.08.2006
 * Time: 9:07:04
 * To change this template use File | Settings | File Templates.
 */

public class FSMotorolaE1000 implements AbstractFileUtils {
    /**
     * Current FileConnection (file or folder).
     */
    private FileConnection connection;
    private String location;
    private boolean showHiddenFiles;
    private FileConnection connectionD;

    public FSMotorolaE1000() {
        showHiddenFiles = false;
        location = "";
    }
    /**
     *  initial = "file://"
     *  location = "/filepath/filename"
     */
    public void setLocation(String loc) {

        location = loc;
    }

    public String getLocation() {
        return location;
    }

    public void close() {
        try {
            if (connection == null)
                return;
            connection.close();
            connection = null;
        } catch(Exception exception) {
           ////System.err.println("Close connection failed: " + exception.getMessage());
        }
    }

//    private boolean wait = false;
    
    public void open(int mode) {
        try {
            close();
            connection = (FileConnection) Connector.open(Addon.file_root + location, mode);
        } catch(Exception exception) {
            connection = null;
           ////System.err.println("Open connection '" + location + "' failed: " + exception.getMessage());
        }
    }


    public void open() {
        open(Connector.READ);
    }

    public long availableSize() {
        long result = -1;
        open();
        if(connection != null) {
            result = connection.availableSize();
            close();
        }
        return result;
    }

    public boolean canRead() {
        boolean result = true;
        open();
        try {
            if(connection != null) {
                result = connection.canRead();
                close();
            }
        } catch (Exception e) {
            result = false;
        }
        return result;
    }

    public boolean canWrite() {
        boolean result = true;
        open();
        try {
            if(connection != null) {
                result = connection.canWrite();
                close();
            }
        } catch (IOException e) {
            result = false;
        }
        return result;
    }

    public boolean create() {
        boolean result = true;
        open(Connector.READ_WRITE);
        try {
            if (connection != null) {
                // TODO   if(connection.exists())
                // TODO       connection.delete();
                connection.create();
                close();
            }
        } catch (Exception e) {  // TODO 
            result = false;
        }
        return result;
    }

    public boolean delete() {
        boolean result = false;
        open(Connector.READ_WRITE);
        try {
            if (connection != null && connection.exists()) {
                connection.delete();
                result = true;
                close();
            }
        } catch (Exception e) {  // TODO 
            result = false;
        }
        return result;
    }

    public long directorySize(boolean includeSubDirs) {
        long result = -1;
        open();
        try {
            if(connection != null) {
                result = connection.directorySize(includeSubDirs);
                close();
            }
        } catch (Exception e) {
            //result = -1;
        }
        return result;
    }

    public boolean exists() {
        boolean result = false;
        open();
        try {
            if(connection != null) {
                result = connection.exists();
                close();
            }
        } catch (Error e) {   //TODO  

        }
        return result;
    }


    public long fileSize() {
        long result = -1;
        open();
        try {
            if(connection != null) {
                result = connection.fileSize();
                close();
            }
        } catch (Exception e) {
            //result = -1;
        }
        return result;
    }

    public boolean isDirectory() {
        boolean result = false;
        open();
        if(connection != null) {
            result = connection.isDirectory();
            close();
        }
        return result;
    }

    public boolean isHidden() {
        boolean result = false;
        open();
        try {
            if(connection != null) {
                result = connection.isHidden();
                close();
            }
        } catch (Exception e) {
            //result = false;
        }
        return result;
    }

    public long lastModified() {
        long result = -1;
        open();
        if(connection != null) {
            result = connection.lastModified();
            close();
        }
        return result;
    }

////////////////////////////////////////////////////////////////////
    public String[] list() {
        String[] as = null;
        open();
        try {
            if(connection != null) {
                Vector vector = new Vector();
                for(Enumeration enumeration = connection.list("*", showHiddenFiles);
                    enumeration.hasMoreElements();
                    vector.addElement(enumeration.nextElement()));
                close();
                as = new String[vector.size()];
                for(int i = 0; i < vector.size(); i++)
                    as[i] = (String)vector.elementAt(i); //as[i] = location + vector.elementAt(i);
            }
        } catch (Exception e) {
            as = new String[0];
           ////System.err.println("Error on list folder " + connection.getURL() + " with message " + e.getMessage());
        }
        return as;
    }

    public String[] listRoots() {
        String[] as = null;

        Vector vector = new Vector();
        for(Enumeration enumeration = FileSystemRegistry.listRoots();
            enumeration.hasMoreElements();
            vector.addElement(enumeration.nextElement()));
        as = new String[vector.size()];
        for(int i = 0; i < vector.size(); i++)
            as[i] = (String)vector.elementAt(i);   //as[i] = "/" + vector.elementAt(i);

        return as;
    }
////////////////////////////////////////////////////////////////////

    public boolean mkdir() {
        boolean result = false;
        open(Connector.WRITE);
        try {
            if (connection != null) {
                connection.mkdir();
                result = true;
                close();
            }
        } catch (Exception e) {
            result = false;
        }
        return result;
    }

    public boolean rename(String s) {
        boolean result = false;
        open(Connector.READ_WRITE);
        try {
            if (connection != null) {
                connection.rename(s);
                close();
            }
        } catch (Exception e) {
        }
        return result;
    }

    public byte[] read() {
        byte[] abyte0;
        try {
            open();
            long l = connection.fileSize();
            InputStream inputstream = (connection.openInputStream());
            abyte0 = new byte[(int)l];
            if(l != (long)inputstream.read(abyte0)) abyte0 = null;
            inputstream.close();
            close();
        } catch(Exception exception) {
            abyte0 = null;
            //System.err.println("Read from '" + location + "' failed: " + exception.getMessage());
        }
        return abyte0;
    }


    public boolean write(byte[] abyte0) {
        return write(abyte0, 0, abyte0.length);
    }


    public boolean write(byte[] abyte0, int offset, int length) {
        boolean flag = false;
        try {
            open(Connector.READ_WRITE);
            if(test_exists()/*connection.exists()*/)
                connection.delete();
            connection.create();
            OutputStream outputstream = connection.openOutputStream();
            outputstream.write(abyte0, offset, length);
            outputstream.flush();
            outputstream.close();
            close();
            flag = true;
        } catch(Exception exception) {
            //System.err.println("Write to '" + location + "' failed: " + exception.getMessage());
        }
        return flag;
    }


    public void setHidden(boolean hidden) {
        open(Connector.READ_WRITE);
        try {
            if(connection != null) {
                connection.setHidden(hidden);
                close();
            }
        } catch (Exception e) {
        }
    }

    public void setReadable(boolean readable) {
        open(Connector.READ_WRITE);
        try {
            if(connection != null) {
                connection.setReadable(readable);
                close();
            }

        } catch (Exception e) {
        }
    }

    public void setWriteable(boolean writeable) {
//        open(Connector.READ_WRITE);
//
//        try {
//            if(connection != null) {
//                connection.setWriteable(writeable); //setWriteable
//                close();
//            }
//        } catch (Exception e) {
//        }
    }

    public long totalSize() {
        long result = -1;
        open();
        if(connection != null) {
            result = connection.totalSize();
            close();
        }
        return result;
    }
//
//    public long usedSize() {
//        long result = -1;
//        open();
//        if(connection != null) {
//            result = connection.usedSize();
//            close();
//        }
//        return result;
//    }

    public boolean copy(String oldFileName, String newFileName){
        FileConnection fc_in;// = null;
        FileConnection fc_out;// = null;
        InputStream dis;// = null;
        OutputStream dos;// = null;
        try {
            fc_in = (FileConnection) Connector.open("file://" + oldFileName);
            fc_out = (FileConnection) Connector.open("file://" + newFileName);
            if (!fc_out.exists()) {
                fc_out.create();
                fc_out.setReadable(true);
                fc_out.setWritable(true);
                fc_out.setHidden(false);
            }

            dis = fc_in.openInputStream();
            dos = fc_out.openOutputStream();
        } catch (Exception e) {
            ////System.err.println("  " + e);
            return false;
        }

        byte[] data;
        try {
            data = new byte[1024]; //
        } catch (OutOfMemoryError oom) {
            System.gc();
            data = new byte[512]; //
        }
        int datalen = data.length;
        int offset = 0;
        int len;// = -1;

        try {
           // long bytes=0;
           // bytes = fc_in.fileSize();
            do {
                len = dis.read(data, offset, datalen);  //    -
                dos.write(data, offset, len);           //     
            } while (len == datalen);
        } catch (Exception e) {
            ////System.err.println("  " + e);
            return false;
        }

        try {
            dis.close();
            dos.flush();
            dos.close();
            fc_in.close();
            fc_out.close();
        } catch (Exception e) {
            ////System.err.println("  " + e);
            return false;
        }

        return true;
    }

    public boolean move(String oldFileName, String newFileName){
        if (copy(oldFileName, newFileName)) {
            try {
                FileConnection fc = (FileConnection) Connector.open("file://" + oldFileName, 2);
                fc.delete();
                fc.close();
                return true;
            } catch (Exception e) {
                ////System.err.println("  " + e);
                return false;
            }
        }
        ////System.err.println("  ");
        return false;
    }



    public InputStream openInputStream() {
        InputStream stream;
        try {
            open();
            stream = connection.openInputStream();
        }
        catch(Exception exception) {
            stream = null;
           ////System.err.println("openInputStream from '" + location + "' failed: " + exception.getMessage());
        }
        return stream;
    }

/*
    public OutputStream openOutputStream() {
        OutputStream stream;
        try {
            open(Connector.READ_WRITE);
            if(connection.exists())
                connection.delete();
            connection.create();
            stream = connection.openOutputStream();
        } catch(Exception exception) {
            stream = null;
           //System.err.println("openOutputStream on '" + location + "' failed: " + exception.getMessage());
        }
        return stream;
    }

    public void closeInputStream(InputStream stream) {
        try {
            stream.close();
        } catch (IOException exception) {
           ////System.err.println("closeInputStream from '" + location + "' failed: " + exception.getMessage());
        }
        close();
    }

    public void closeOutputStream(OutputStream stream) {
        try {
            stream.flush();
            stream.close();
        } catch (IOException exception) {
           ////System.err.println("closeOutputStream on '" + location + "' failed: " + exception.getMessage());
        }
        close();
    }
*/



    public void setShowHidden(boolean b) {
        showHiddenFiles = b;
    }

    public boolean getShowHidden() {
        return showHiddenFiles;
    }


}


